
/* structure to store a 3d point, note that for this assignment, the vector also stores a level which is used to
   denote which level of subdivion has been computed on that point (to not displace a point twice), given the 
   data structure we are using */
typedef struct Vector3 {
  float x;
  float y;
  float z;
  
  int level;
  Vector3(float in_x, float in_y, float in_z) : x(in_x), y(in_y), z(in_z), level(0) {}
  Vector3() : x(0), y(0), z(0), level(0) {}
  Vector3(const Vector3& in_v) : x(in_v.x), y(in_v.y), z(in_v.z), level(0) {}
  Vector3(float in) : x(in), y(in), z(in), level(0) {}
  inline Vector3& operator =(const Vector3& v2) { x = v2.x; y=v2.y; z=v2.z; level =v2.level; return *this;}
  inline void set(float in_x, float in_y, float in_z) { x = in_x; y = in_y; z = in_z; level = 0;}
} Vector3;
